LeetCode#594: LongestHarmoniousSubsequence

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/qq_38283262/article/details/83545337

Description

We define a harmonious array is an array where the difference between its maximum value and its minimum value is exactly 1.

Now, given an integer array, you need to find the length of its longest harmonious subsequence among all its possible subsequences.

Example

Example 1:
Input: [1,3,2,2,5,2,3,7]
Output: 5
Explanation: The longest harmonious subsequence is [3,2,2,2,3].

Note

  • The length of the input array will not exceed 20,000.

Solution

根据题意可知,harmonious子序列里面肯定只有两个值,这时候才能满足最大值与最小值相差为1。因此,我们可以使用HashMap将每个值出现的次数记录下来,相邻两个差为1的且出现次数和最大的两个值即为harmonious最长子序列里的值。例如:

输入:[1,3,2,2,5,2,3,7]
Map:
值:       1 2 3 5 7
---------------------
出现次数:  1 3 2 1 1

2和3之间相差1,且出现次数为3+2=5是最大的,所以harmonious最长子序列为[3,2,2,2,3]

class Solution {
    public int findLHS(int[] nums) {
    	if(nums == null || nums.length == 0)
    		return 0;
        HashMap<Integer, Integer> map = new HashMap<>();
        int max = 0;
        for(int i = 0; i < nums.length; i++) {
        	map.put(nums[i], map.getOrDefault(nums[i], 0)+1);
        }
        for(Map.Entry<Integer, Integer> entry : map.entrySet()) {
        	int key = entry.getKey();
        	int val = entry.getValue();
        	if(map.containsKey(key+1)) {
        		max = max > val + map.get(key+1) ? max : val + map.get(key+1);
        	}
        }
        return max;
    }
}

猜你喜欢

转载自blog.csdn.net/qq_38283262/article/details/83545337